/*Library for 8051 serial communication.
  Created by Er. Raj Virk (Aar Softronix), October 27, 2016.
  Released into the public domain.*/

void beginSerial(char);
char readSerial(void);
void writeSerialChar(char);
void writeSerialString(char *txString);
void sendingByte(void);

void beginSerial(char baudRate)
{
TMOD=0x20;
SCON=0x50;
TH1=baudRate;
TR1_bit=1;
}

readSerial()
{
char rxByte;
 if(RI_bit==1)
 {
 rxByte=SBUF;
 RI_bit=0;
 return rxByte;
 }
}

void writeSerialByte(char txByte)
{
SBUF=txByte;
sendingByte();
}

void writeSerialString(char *txString)
{
 while(*txString!='\0')
 {
 SBUF=*txString;
 sendingByte();
 txString++;
 }
}

void sendingByte()
{
while(TI_bit==0);
TI_bit=0;
}